/*	File:	ai.c
	Author:	Nancy Montanez
	Date:	March 13, 2001
	Description:	enemy AI
*/

#include <stdio.h>
#include <stdlib.h>

#include "server.h"

#include "dmz_net.h"
#include "dmzcore.h"

#define MAXCOUNT 20
#define MAXHEIGHT 5

char buf[256];

GLOBAL int sgdwFrame;

void ApplyAI(WORD16 objid)
{
	struct dmz_message m;
	WORD16 dir = dmz_objects[objid]->u.player.direction;
	int velocity = dmz_objects[objid]->velocity;
	int directionX = 0;
	int directionY = 0;
	
	WORD32 new_x, new_y;
	WORD32 old_x, old_y;
	int colid;
	CELL cell;
	short dam, spd;

	if ((sgdwFrame % 100) == 0)
	{
		dir = (WORD16) (rand() % 8);
		dmz_objects[objid]->u.player.direction = dir;
	}
	dmz_scale_delta(dir, &directionX, &directionY);

	old_x = dmz_objects[objid]->x;
	old_y = dmz_objects[objid]->y;

	/* update player's position */
	new_x = dmz_objects[objid]->x += velocity * directionX;
	new_y = dmz_objects[objid]->y += velocity * directionY;

	/* check if out of bounds */
	if (new_x > map_width * PIXELS_PER_CELL ||
		new_y > map_height * PIXELS_PER_CELL)
	{
		/* undo the move */
		dmz_objects[objid]->x = old_x;
		dmz_objects[objid]->y = old_y;
		return;
	}

	if (!ValidMove(dir, objid))
	{
		/* undo the move */
		dmz_objects[objid]->x = old_x;
		dmz_objects[objid]->y = old_y;
		return;
	}

	colid = DetectCollision((WORD16) objid);
	if (colid > 0)
	{
		if (dmz_objects[colid]->objtype == PLAYER)
			MissileAttack(objid, dmz_objects[objid]->u.player.direction);
		
		
		/* undo the move */
		dmz_objects[objid]->x = old_x;
		dmz_objects[objid]->y = old_y;
		
		return;
	}

	/* apply damage and speed change, if applicable */
	cell = dmz_world_map[new_x / PIXELS_PER_CELL][new_y / PIXELS_PER_CELL];
	dmz_map_get_prop(cell, NULL, &dam, &spd);

	dmz_objects[objid]->velocity = (WORD16) (DEFAULT_VELOCITY + spd);
/*	if (dam != 0)
		ApplyDamage(objid, dam);
*/
	/* inform the clients of new coordinates */
	m.type = MOVE;
	m.objid = objid;
	m.u.move.new_x = new_x;
	m.u.move.new_y = new_y;
	m.u.move.direction = dir;
	dmz_broadcast(&m);

	/* decide whether or not to shoot */
/*	if ((rand() % 4) == 0)
	{
		MissileAttack(objid, dmz_objects[objid]->u.player.direction);

		memset(&m, 0, sizeof(struct dmz_message));
		m.type = MOVE;
		m.objid = objid;
		m.u.attack.method = PROJECTILE;
		dmz_broadcast(&m);
	}*/
}
