/*	File:	init.h
	Author:	Alex Fedosov
	Date:	December 13, 2000
	Description:	common init functions interface
*/

#ifndef __INIT_H__
#define __INIT_H__

/* CSV-related */

#define MAXLINE 256
#define CSV_FIELDS 10
#define CSV_TER_FIELDS 6

enum {
	CSV_NAME, CSV_BIT, CSV_DEAD, CSV_HP, CSV_DAM, CSV_ARM,
	CSV_VAL, CSV_KIND, CSV_X, CSV_Y
};

enum {
	CSV_TER_FILE, CSV_TER_GRP, CSV_TER_PROB, CSV_TER_PASS,
	CSV_TER_SPD, CSV_TER_DAM
};

int dmz_data_init(void);
int dmz_load_CSV(char *filename);
int dmz_load_terrain(char *csvfile, char *mapfile);

/* functions for randomizing terrain */

#define MAXGROUPS 499
#define MAXTILESPERGROUP 16

void init_groups(void);
void destroy_groups(void);
int add_to_group(unsigned int tile, unsigned int grp, unsigned int prob);
unsigned int get_random_tile(int grp);
int find_transition_tile(int cur, int prev, int top, int diag);

#endif
