/*	File:	lock.h
	Author:	Alex Fedosov
	Date:	November 16, 2000
	Description:	Win32 synchronization primitives
*/

#if !defined(_WIN32)
#error "This is a Win32 include file and you are compiling for something else!"
#endif

#ifndef __LOCK_H__
#define __LOCK_H__

#ifndef _MT
#define _MT
#endif

#include "windows.h"

typedef CRITICAL_SECTION lock_t;

#define lock_init(x) InitializeCriticalSection(&x)
#define lock_destroy(x) DeleteCriticalSection(&x)
#define mutex_lock(x) EnterCriticalSection(&x)
#define mutex_unlock(x) LeaveCriticalSection(&x)

typedef HANDLE __lock_t;
#define __lock_init(x) x = CreateSemaphore(NULL, 1, 1, NULL)
#define __lock_destroy(x) CloseHandle(x)
#define __mutex_lock(x) WaitForSingleObject(x, INFINITE)
#define __mutex_unlock(x) ReleaseSemaphore(x, 1, NULL)

#endif